minor improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8
9
10 if [[ -s /a/bin/errhandle/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source /a/bin/errhandle/err
13 # wtf, shellcheck doesn't allow disabling warnings in elifs
14 else
15 # bleh shellcheck can't handle disabling in an elif, so nesting this if.
16 # shellcheck disable=SC2154 # set in .bashrc
17 if [[ -s $bashrc_dir/err ]]; then
18 # shellcheck source=/a/bin/errhandle/err
19 source $bashrc_dir/err
20 fi
21 fi
22
23 # In t8, it runs clear_console for login shells by default. I don't want
24 # my console cleared. And linux ttys get cleared without this.
25 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
26 rm ~/.bash_logout
27 fi
28
29 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
30 # source /usr/share/bash-completion/completions/git
31 # fi
32 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
33 # source /usr/share/bash-completion/completions/gitk
34 # fi
35
36 # for testing error catching:
37 # t2() {
38 # echo t2
39 # grep sdf sdfd
40 # echo wtf
41 # }
42 # t1() {
43 # echo t1
44 # t2 a b c
45 # }
46
47 # * settings
48
49 CDPATH=.
50
51
52 # remove all aliases. aliases provided by the system tend to get in the way,
53 # for example, error happens if I try to define a function the same name as an alias
54 unalias -a
55
56 # remove gnome keyring warning messages
57 # there is probably a more proper way, but I didnt find any easily on google
58 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
59 #unset GNOME_KEYRING_CONTROL
60
61 # use extra globing features.
62 shopt -s extglob
63 # include .files when globbing, but ignore files name . and ..
64 # setting this also sets dotglob.
65 export GLOBIGNORE="*/.:*/.."
66
67 # Useful info. see man bash.
68 PS4='$LINENO+ '
69
70
71 # broken with bash_completion package. Saw a bug for this once. dont anymore.
72 # still broken in wheezy
73 # still buggered in latest stable from the web, version 2.1
74 # perhaps its fixed in newer git version, which fails to make for me
75 # this note is from 6-2014.
76 # still broken in flidas.
77 #shopt -s nullglob
78
79 # make tab on an empty line do nothing
80 shopt -s no_empty_cmd_completion
81
82 # fix spelling errors for cd, only in interactive shell
83 shopt -s cdspell
84 # append history instead of overwritting it
85 shopt -s histappend
86 # for compatibility, per gentoo/debian bashrc
87 shopt -s checkwinsize
88 # attempt to save multiline single commands as single history entries.
89 shopt -s cmdhist
90 # enable **
91 shopt -s globstar
92
93
94 # inside emacs fixes
95 if [[ $LC_INSIDE_EMACS ]]; then
96 # EMACS is used by bash on startup, but we dont need it anymore.
97 # plus I hit a bug in a makefile which inherited it
98 unset EMACS
99 export LC_INSIDE_EMACS
100 export PAGER=cat
101 export MANPAGER=cat
102 # scp completion does not work, but this doesnt fix it. todo, figure this out
103 #complete -r scp &> /dev/null
104 # todo, remote file completion fails, figure out how to turn it off
105 export NODE_DISABLE_COLORS=1
106 # This gets rid of ugly terminal escape chars in node repl
107 # sometime, Id like to have completion working in emacs shell for node
108 # the offending chars can be found in lib/readline.js,
109 # things that do like:
110 # stream.write('\x1b[' + (x + 1) + 'G');
111 # We can remove them and keep readline, for example by doing this
112 # to start a repl:
113 #!/usr/bin/env nodejs
114 # var readline = require('readline');
115 # readline.cursorTo = function(a,b,c) {};
116 # readline.clearScreenDown = function(a) {};
117 # const repl = require('repl');
118 # var replServer = repl.start('');
119 #
120 # no prompt, or else readline complete seems to be confused, based
121 # on our column being different? node probably needs to send
122 # different kind of escape sequence that is not ugly. Anyways,
123 # completion doesnt work yet even with the ugly prompt, so whatever
124 #
125 export NODE_NO_READLINE=1
126
127 fi
128
129 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
130
131 # emacs has a different default search path than the info command. This
132 # adds the info defaults to emacs, but not the reverse, because I dun
133 # care much about the cli. The search path is only on the cli if you run
134 # "info xxx", or in emacs if you run '(info xxx)', so not that
135 # important, but might as well fix it.
136
137 # info info says this path is what was compiled, and its not documented
138 # anywhere. Through source grepping, i found it in filesys.h of the info
139 # source in trisquel flidas.
140 #
141 # Traling : means for emacs to add its own stuff on to the end.
142
143 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
144
145 # for openwrt system that has no stty, this is easier than
146 # guarding every time i use it.
147 if ! type -p stty >/dev/null; then
148 stty() { :; }
149 fi
150
151
152 use_color=false
153 if [[ $- == *i* ]]; then
154 # for readline-complete.el
155 if [[ $LC_INSIDE_EMACS ]]; then
156 # all for readline-complete.el
157 stty echo
158 bind 'set horizontal-scroll-mode on'
159 bind 'set print-completions-horizontally on'
160 bind '"\C-i": self-insert'
161 else
162
163
164 if [[ $TERM != dumb ]] && test -t 1; then
165 use_color=true
166 fi
167
168 if [[ $KONSOLE_PROFILE_NAME ]]; then
169 TERM=xterm-256color
170 fi
171
172 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
173 # todo: we should try installing the alacritty terminfo if it is not found
174 # https://github.com/alacritty/alacritty/issues/2838
175 TERM=xterm-256color
176 fi
177
178 # copying from the alacritty example above,
179 if [[ $TERM == xterm-kitty ]]; then
180 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
181 TERM=xterm-256color
182 else
183 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
184 KITTY_SHELL_INTEGRATION=t
185 source /a/opt/kitty/shell-integration/bash/kitty.bash
186 fi
187 fi
188 fi
189
190 # todo: not sure this works in sakura
191 #stty werase undef
192 #bind "\C-w": kill-region
193 # sakura == xterm-256color
194 # konsole == xterm
195 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
196 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
197 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
198 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
199 else
200 # make ctrl-backspace work. for konsole, i fixed it through
201 # /home/iank/.local/share/konsole/default.keytab
202 stty werase ^h
203 bind '"\eOc": shell-forward-word'
204 bind '"\eOd": shell-backward-word'
205 fi
206 # i cant remember why i did this, probably to free up some keys to bind
207 # to other things in bash.
208 # other than C-c and C-z, the rest defined by stty -a are, at least in
209 # gnome-terminal, overridden by bash, or disabled by the system
210 stty lnext undef stop undef start undef
211 fi
212
213 fi
214
215 case $TERM in
216 # fixup broken backspace in chroots
217 xterm-kitty|alacritty)
218 chroot() {
219 TERM=xterm-256color command chroot "$@"
220 }
221 ;;
222 esac
223
224 export BC_LINE_LENGTH=0
225
226 # ansible option
227 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
228
229 # note, if I use a machine I dont want files readable by all users, set
230 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
231
232 # i for insensitive. the rest from
233 # X means dont remove the current screenworth of output upon exit
234 # R means to show colors n things
235 # a useful flag is -F aka --quit-if-one-screen
236 export LESS=RXij12
237 export SYSTEMD_LESS=$LESS
238
239 export NNN_COLORS=2136
240
241 export SL_FILES_DIR=/b/ds/sl/.iank
242 export SL_INFO_DIR=/p/sshinfo
243
244
245
246 # * include files
247
248 if [[ -s $bashrc_dir/path-add-function ]]; then
249 source $bashrc_dir/path-add-function
250 if [[ $SSH_CLIENT ]]; then
251 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
252 export EMACSDIR=/home/iank/.iank/e/e
253 fi
254 path-add $bashrc_dir
255 fi
256 fi
257
258 # if someone exported $SOE (stop on error), catch errors.
259 #
260 # Note, on debian this results in the following warning when in ssh,
261 # hich I haven't figured out how to fix. It doesn't happen if we source
262 # after the shell has started
263 #
264 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
265 # bash: warning: cannot start debugger; debugging mode disabled
266 if [[ $SOE ]]; then
267 if [[ -e /a/bin/errhandle/err ]]; then
268 source /a/bin/errhandle/err
269 fi
270 fi
271
272
273 mysrc() {
274 local path dir file
275 path=$1
276 dir=${path%/*}
277 file=${path##*/}
278 if [[ -s $path ]]; then
279 # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
280 source $path
281 elif [[ -s $bashrc_dir/$file ]]; then
282 # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
283 source $bashrc_dir/$file
284 fi
285 }
286
287
288 mysrc /a/bin/small-misc-bash/ll-function
289 mysrc /a/bin/distro-functions/src/package-manager-abstractions
290
291 # things to remember:
292 # ALT-C - cd into the selected directory
293 # CTRL-T - Paste the selected file path into the command line
294 #
295 # good guide to some of its basic features is the readme file
296 # https://github.com/junegunn/fzf
297
298 # if [[ -s /usr/share/doc/fzf/examples/key-bindings.bash ]]; then
299 # source /usr/share/doc/fzf/examples/key-bindings.bash
300 # fi
301
302 # * functions
303
304
305 # temporary functions
306 y() {
307 m "${@//spring/fall}"
308 }
309 h() {
310 e "${@//spring/fall}"
311 }
312
313
314 ### begin FSF section ###
315
316 # Comments before functions are meant to be good useful
317 # documentation. If they fail at that, please improve them or send Ian a
318 # note.
319
320 ## copy bash completion
321 # Usage: ORIGINAL_COMMAND TARGET_COMMAND...
322 #
323 # It copies how the bash completion works from one command to other
324 # commands.
325 ccomp() {
326 local c src
327 src=$1
328 shift
329 if ! c=$(complete -p $src 2>/dev/null); then
330 _completion_loader $src &>/dev/null ||:
331 c=$(complete -p $src 2>/dev/null) || return 0
332 fi
333 # remove $src( .*|$)
334 c=${c% "$src"}
335 c=${c%% "$src" *}
336 eval $c $*
337 }
338
339 ## BEGIN directory history tracking and navigation.
340 #
341 # use c instead of cd (could alias to cd if you wanted). b to go back, f
342 # to go forward, cl to list recent directories and choose one.
343 #
344 # The finer details you may want to skip:
345 #
346 # We also define bl to print the list of back and forward directories.
347 #
348 # We keep 2 stacks, forward and back. Unlike with a web browser, the
349 # forward stack is not erased when going somewhere new.
350 #
351 # Recent directories are stored in ~/.cdirs.
352 #
353 declare -a _dir_forward _dir_back
354 c() {
355 # normally, the top of _dir_back is our current dir. if it isn't,
356 # put it on there, except we don't want to do that when we
357 # just launched a shell
358 if [[ $OLDPWD ]]; then
359 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
360 _dir_back+=("$PWD")
361 fi
362 fi
363 command cd "$@"
364 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
365 _dir_back+=("$PWD")
366 fi
367 echo "$PWD" >> ~/.cdirs
368 }
369 ccomp cd c
370
371 # back
372 b() {
373 local top_back
374 if (( ${#_dir_back[@]} == 0 )); then
375 echo "nothing left to go back to" >&2
376 return 0
377 fi
378 top_back="${_dir_back[-1]}"
379
380 if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
381 echo "already on last back entry" >&2
382 return 0
383 fi
384
385
386 if [[ $top_back == "$PWD" ]]; then
387 # add to dirf if not already there
388 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
389 _dir_forward+=("$top_back")
390 fi
391 unset "_dir_back[-1]"
392 command cd "${_dir_back[-1]}"
393 else
394 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
395 _dir_forward+=("$PWD")
396 fi
397 command cd "$top_back"
398 fi
399
400 # Interesting feature, not sure I want it.
401 # give us a peek at what is next in the list
402 # if (( ${#_dir_back[@]} >= 2 )); then
403 # printf "%s\n" "${_dir_back[-2]}"
404 # fi
405 #
406
407 # c/b/f Implementation notes:
408 #
409 # The top of the back is $PWD
410 # as long as the last directory change was due to c,b,or cl.
411 #
412 # Example of stack changes:
413 #
414 # a b c (d)
415 ## back
416 # a b (c)
417 # d
418 #back
419 #a (b)
420 #d c
421 #back
422 #(a)
423 #d c b
424 #forward
425 #a (b)
426 #d c
427 #
428 # a b c
429 ## back
430 # a b
431 # (c)
432 ## forward
433
434 }
435 # forward
436 f() {
437 local top_forward
438 if (( ${#_dir_forward[@]} == 0 )); then
439 echo "no forward dir left" >&2
440 return 0
441 fi
442 top_forward="${_dir_forward[-1]}"
443 unset "_dir_forward[-1]"
444 c "$top_forward"
445
446 # give us a peek at what is next in the list
447 # if (( ${#_dir_forward[@]} )); then
448 # printf "%s\n" "${_dir_forward[-1]}"
449 # fi
450 }
451 # cd list
452 cl() {
453 local i line input start
454 local -A buttondirs alines
455 local -a buttons dirs lines
456 buttons=( {a..z} {2..9} )
457 if [[ ! -s ~/.cdirs ]]; then
458 echo nothing in ~/.cdirs
459 return 0
460 fi
461
462 i=0
463
464 mapfile -t lines <~/.cdirs
465 start=$(( ${#lines[@]} - 1 ))
466
467 # we have ~33 buttons as of this writing, so lets
468 # prune down the history every once in a while.
469 if (( start > 500 )); then
470 tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
471 fi
472
473 for (( j=start; j >= 0; j-- )); do
474 line="${lines[$j]}"
475 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
476 continue
477 fi
478 alines[$line]=t
479 buttondirs[${buttons[i]}]="$line"
480 printf "%s %s\n" ${buttons[i]} "$line"
481 # the LINES bit is for when we have a short terminal, just dont print all
482 # the directories. alternative would be to do something like less the list.
483 if (( i == ${#buttons[@]} - 1 )) || { [[ $LINES ]] && (( i == LINES - 3 )); }; then
484 break
485 fi
486 i=$(( i + 1 ))
487 done
488
489 if (( i == 0 )); then
490 echo "no dirs in ~/.cdirs"
491 return 0
492 fi
493 read -r -N 1 input
494 if [[ $input != $'\n' ]]; then
495 c "${buttondirs[$input]}"
496 fi
497 }
498 # list the back and forward directories. i tend to forget this exists
499 # and use cl instead.
500 bl() {
501 local start i j max
502 max=10
503 start=$(( ${#_dir_back[@]} - 1 ))
504
505 # cleanup possible repeating of pwd
506 if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
507 start=$(( start - 1 ))
508 fi
509 j=1
510 if (( start >= 0 )); then
511 for (( i=start; i >= 0 ; i-- )); do
512 printf "%s %s\n" $j ${_dir_back[i]}
513 j=$(( j + 1 ))
514 if (( j >= max )); then
515 break
516 fi
517 done
518 fi
519
520 max=10
521 start=$(( ${#_dir_forward[@]} - 1 ))
522
523 # cleanup possible repeating of pwd
524 if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
525 start=$(( start - 1 ))
526 fi
527 if (( start < 0 )); then
528 return 0
529 fi
530 echo --
531 j=1
532 for (( i=start; i >= 0 ; i-- )); do
533 printf "%s %s\n" $j ${_dir_forward[i]}
534 j=$(( j + 1 ))
535 if (( j >= max )); then
536 break
537 fi
538 done
539 }
540
541 # pee do. run args as a command with output copied to syslog.
542 #
543 # Usage: pd [-t TAG] COMMAND...
544 #
545 # -t TAG Override the tag in the syslog. The default is COMMAND with
546 # any path part is removed, eg. for /bin/cat the tag is cat.
547 #
548 # You can view the log via "journalctl -t TAG"
549 pd() {
550 local tag ret
551 ret=0
552 tag=${1##*/}
553 case $1 in
554 -t) tag="$2"; shift 2 ;;
555 esac
556 echo "PWD=$PWD command: $*" | logger -t $tag
557 "$@" |& pee cat "logger -t $tag" || ret=$?
558 echo "exited with status=$ret" | pee cat "logger -t $tag"
559 # this avoids any err-catch
560 (( ret == 0 )) || return $ret
561 }
562 ccomp time pd
563
564 # jdo = journal do. Run command as transient systemd service, tailing
565 # its output in the journal until it completes.
566 #
567 # Usage: jdo COMMAND...
568 #
569 # Compared to pd: commands recognize this is a non-interactive shell.
570 # The service is unaffected if our ssh connection dies, no need to run
571 # in screen or tmux.
572 #
573 # Note: The last few lines of any existing entries for a unit by that
574 # name will be output first, and there will be a few second delay at the
575 # start of the command, and a second or so at the end.
576 #
577 # Note: Functions and aliases obviously won't work, we resolve the
578 # command to a file.
579 #
580 # Note: requires running as root.
581 jdo() {
582 local cmd cmd_name jr_pid ret
583 ret=0
584 cmd="$1"
585 shift
586 if [[ $EUID != 0 ]]; then
587 echo "jdo: error: rerun as root"
588 return 1
589 fi
590 cmd_name=${cmd##*/}
591 if [[ $cmd != /* ]]; then
592 cmd=$(type -P "$cmd")
593 fi
594 # -q = quiet
595 journalctl -qn2 -f -u "$cmd_name" &
596 # Trial and error of time needed to avoid missing initial lines.
597 # .5 was not reliable. 1 was not reliable. 2 was not reliable
598 sleep 4
599 jr_pid=$!
600 systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
601 # The sleep lets the journal output its last line
602 # before the prompt comes up.
603 sleep .5
604 kill $jr_pid &>/dev/null ||:
605 unset jr_pid
606 fg &>/dev/null ||:
607 # this avoids any err-catch
608 (( ret == 0 )) || return $ret
609 }
610 ccomp time jdo
611 #### end fsf section
612
613
614 ..() { c ..; }
615 ...() { c ../..; }
616 ....() { c ../../..; }
617 .....() { c ../../../..; }
618 ......() { c ../../../../..; }
619
620 chere() {
621 local f path
622 for f; do
623 path=$(readlink -e "$f")
624 echo "cat >$path <<'EOF'"
625 cat "$f"
626 echo EOF
627 done
628 }
629
630
631 # file cut copy and paste, like the text buffers :)
632 # I havnt tested these.
633 _fbufferinit() { # internal use
634 ! [[ $my_f_tempdir ]] && my_f_tempdir="$(mktemp -d)"
635 rm -rf "${my_f_tempdir:?}"/*
636 }
637 fcp() { # file cp
638 _fbufferinit
639 cp "$@" "$my_f_tempdir"/
640 }
641 fct() { # file cut
642 _fbufferinit
643 mv "$@" "$my_f_tempdir"/
644 }
645 fpst() { # file paste
646 [[ $2 ]] && { echo too many arguments; return 1; }
647 target=${1:-.}
648 cp "$my_f_tempdir"/* "$target"
649 }
650
651 _khfix_common() {
652 local host ip port file key
653 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
654 file=$(readlink -f ~/.ssh/known_hosts)
655 if [[ ! $ip ]]; then
656 echo "khfix: ssh failed"
657 return 1
658 fi
659 if [[ $port != 22 ]]; then
660 ip_entry="[$ip]:$port"
661 host_entry="[$host]:$port"
662 else
663 ip_entry=$ip
664 host_entry=$host
665 fi
666 if [[ $host != "$ip" ]]; then
667 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
668 if [[ $key ]]; then
669 grep -Fv "$key" "$file" | sponge "$file"
670 fi
671 fi
672 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
673 if [[ $key ]]; then
674 grep -Fv "$key" "$file" | sponge "$file"
675 fi
676 ll ~/.ssh/known_hosts
677 rootsshsync
678 }
679 khfix() { # known hosts fix
680 _khfix_common "$@" || return 1
681 ssh $1 :
682 }
683 khcopy() {
684 _khfix_common "$@"
685 ssh-copy-id $1
686 }
687
688 # ya, hacky hardcoded hostnames in 2023. we could do better
689 hssh-update() {
690 local -a failed_hosts hosts
691 case $HOSTNAME in
692 sy|kd)
693 hosts=(
694 kd x3.office.fsf.org syw
695 )
696 ;;
697 x3)
698 hosts=(
699 b8.nz sywg.b8.nz
700 )
701 ;;
702 esac
703 for host in ${hosts[@]}; do
704 e $host
705 if ! scp /b/fai/fai/config/files/usr/local/bin/hssh/IANK root@$host:/usr/local/bin/hssh; then
706 failed_hosts+=($host)
707 fi
708 done
709 if (( ${#failed_hosts[@]} >= 1 )); then
710 echo failed_hosts=${failed_hosts[*]}
711 return 1
712 fi
713 }
714
715 a() {
716 local x
717 x=$(readlink -nf "${1:-$PWD}")
718 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
719 echo -n "$x" | xclip -selection clipboard
720 echo -n "$x" | xclip
721 }
722
723 # a1 = awk {print $1}
724 for field in {1..20}; do
725 eval a$field"() { awk '{print \$$field}'; }"
726 done
727 # h1 = head -n1
728 for num in {1..9}; do
729 eval h$num"() { head -n$num || [[ \$? == 141 ]]; }"
730 done
731
732
733 hexipv4() {
734 # shellcheck disable=SC2046 disable=SC2001 disable=SC2183 # hacks, expected
735 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
736 }
737
738 vp9() {
739 local f out outdir in fname origdir skip1
740 origdir="$PWD"
741 outdir=vp9
742 skip1=false
743 while [[ $1 == -* ]]; do
744 case $1 in
745 # if we got interrupted after 1st phase
746 -2)
747 skip1=true
748 shift
749 ;;
750 --out)
751 outdir=$2
752 shift 2
753 ;;
754 esac
755 done
756 m mkdir -p $outdir
757 # first pass only uses about 1 cpu, so run in parallel
758 for f; do
759 {
760 fname="${f##*/f}"
761 if [[ $f == /* ]]; then
762 in="$f"
763 else
764 in=$origdir/$f
765 fi
766 out="$origdir/$outdir/$fname"
767 mkdir -p /tmp/vp9/$fname
768 cd /tmp/vp9/$fname
769 if ! $skip1 && [[ ! -s ffmpeg2pass-0.log ]]; then
770 # -nostdin or else wait causes ffmpeg to go into stopped state. dunno why, random stackoverflow answer.
771 m ffmpeg -nostdin -hide_banner -loglevel error -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
772 fi
773 if [[ -e $out ]]; then rm -f $out; fi
774 m ffmpeg -nostdin -hide_banner -loglevel error -y -i $in -g 192 -vcodec libvpx-vp9 -tile-rows 2 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
775 } &
776 done
777 wait -f
778 cd "$origdir"
779 }
780
781 utcl() { # utc 24 hour time to local hour 24 hour time
782 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
783 }
784
785 bwm() {
786 s bwm-ng -T avg -d
787 }
788
789
790 # for running in a fai rescue. iank specific.
791 kdrescue() {
792 d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
793 for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
794 cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
795 cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
796 done
797 mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
798 mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
799 mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
800 mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
801 cd /mnt
802 chrbind
803 }
804
805
806
807
808 c4() { c /var/log/exim4; }
809
810 caa() { git commit --amend --no-edit -a; }
811
812 cf() {
813 for f; do
814 hr
815 echo "$f"
816 hr
817 cat "$f"
818 done
819 }
820 caf() {
821 # shellcheck disable=SC2033
822 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
823 -o -name .hg -prune -o -name .editor-backups -prune \
824 -o -name .undo-tree-history -prune \) \
825 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
826
827 }
828 ccomp cat cf caf
829
830 calc() { echo "scale=3; $*" | bc -l; }
831 # no having to type quotes, but also no command history:
832 clc() {
833 local x
834 read -r x
835 echo "scale=3; $x" | bc -l
836 }
837
838 cam() {
839 git commit -am "$*"
840 }
841
842 ccat () { # config cat. see a config without extra lines.
843 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
844 }
845 ccomp grep ccat
846
847 chrbind() {
848 local d
849 # dev/pts needed for pacman signature check
850 for d in dev proc sys dev/pts; do
851 [[ -d $d ]]
852 if ! mountpoint $d &>/dev/null; then
853 m s mount -o bind /$d $d
854 fi
855 done
856 }
857 chumount() {
858 local d
859 # dev/pts needed for pacman signature check
860 for d in dev/pts dev proc sys; do
861 [[ -d $d ]]
862 if mountpoint $d &>/dev/null; then
863 m s umount $d
864 fi
865 done
866 }
867
868
869 _cdiff-prep() {
870 # join options which are continued to multiples lines onto one line
871 local first=true
872 while IFS= read -r line; do
873 # remove leading spaces/tabs. assumes extglob
874 if [[ $line == "[ ]*" ]]; then
875 line="${line##+( )}"
876 fi
877 if $first; then
878 pastline="$line"
879 first=false
880 elif [[ $line == *=* ]]; then
881 echo "$pastline" >> "$2"
882 pastline="$line"
883 else
884 pastline="$pastline $line"
885 fi
886 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
887 echo "$pastline" >> "$2"
888 }
889
890 cdiff() {
891 # diff config files,
892 # setup for format of postfix, eg:
893 # option = stuff[,]
894 # [more stuff]
895 local pastline unified f1 f2
896 unified="$(mktemp)"
897 f1="$(mktemp)"
898 f2="$(mktemp)"
899 _cdiff-prep "$1" "$f1"
900 _cdiff-prep "$2" "$f2"
901 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
902 while IFS= read -r line; do
903 # the default bright red / blue doesnt work in emacs shell
904 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
905 done < "$unified"
906 }
907
908
909 cat-new-files() {
910 local start=$SECONDS
911 local dir="$1"
912 # shellcheck disable=SC2030
913 inotifywait -m "$dir" -e create -e moved_to | \
914 while read -r filedir _ file; do
915 cat "$filedir$file"
916 hr
917 calc $((SECONDS - start)) / 60
918 sleep 5
919 done
920
921 }
922
923 chownme() {
924 s chown -R $USER:$USER "$@"
925 }
926
927 # shellcheck disable=SC2032
928 chown() {
929 # makes it so chown -R symlink affects the symlink and its target.
930 if [[ $1 == -R ]]; then
931 shift
932 command chown -h "$@"
933 command chown -R "$@"
934 else
935 command chown "$@"
936 fi
937 }
938
939 cim() {
940 git commit -m "$*"
941 }
942
943
944 d() { builtin bg "$@"; }
945 ccomp bg d
946
947 # f would be more natural, but i already am using it for something
948 z() { builtin fg "$@"; }
949 ccomp fg z
950
951 x() { builtin kill %%; }
952
953 dc() {
954 diff --strip-trailing-cr -w "$@" # diff content
955 }
956 ccomp diff dc
957
958 despace() {
959 local x y
960 for x in "$@"; do
961 y="${x// /_}"
962 safe_rename "$x" "$y"
963 done
964 }
965
966 # df progress
967 # usage: dfp MOUNTPOINT [SECOND_INTERVAL]
968 # SECOND_INTERVAL defaults to 90
969 dfp() {
970 # mp = mountpoint
971 local a b mp interval
972 mp=$1
973 interval=${2:-90}
974 if [[ ! $mp ]]; then
975 echo "dfp: error, missing 1st arg" >&2
976 return 1
977 fi
978 while true; do
979 a=$(df --output=used $mp | tail -n1)
980 sleep $interval
981 b=$(df --output=used $mp | tail -n1)
982 printf "used mib: %'d mib/min: %s\n" $(( b /1000 )) $(( (b-a) / (interval * 1000 / 60 ) ))
983 done
984 }
985
986 # get ipv4 ip from HOST. or if it is already a number, return that
987 hostip() {
988 local host="$1"
989 case $host in
990 [0-9:])
991 echo "$host"
992 ;;
993 *)
994 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
995 ;;
996 esac
997 }
998
999 dig() {
1000 command dig +nostats +nocmd "$@"
1001 }
1002 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
1003 digsort() {
1004 local sec
1005 sec=
1006 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
1007 if [[ $l == [^\;]* ]]; then
1008 sec+="$l"$'\n'
1009 else
1010 if [[ $sec ]]; then
1011 printf "%s" "$sec" | sort
1012 sec=
1013 fi
1014 printf "%s\n" "$l"
1015 fi
1016 done
1017 }
1018 ccomp dig digsort
1019 # compare digs to the 2 servers
1020 # usage: digdiff @server1 @server2 DIG_ARGS
1021 # note: only the soa master nameserver will respond with
1022 # ra "recursive answer" flag. That difference is meaningless afaik.
1023 digdiff() {
1024 local s1 s2
1025 s1=$1
1026 shift
1027 s2=$1
1028 shift
1029 digsort $s1 "$@" | tee /tmp/digdiff
1030 diff -u /tmp/digdiff <(digsort $s2 "$@")
1031 }
1032
1033 # date in a format i like reading
1034 dt() {
1035 date "+%A, %B %d, %r" "$@"
1036 }
1037 dtr() {
1038 date -R "$@"
1039 }
1040 # date with all digits in a format i like
1041 dtd() {
1042 date +%F_%T% "$@"
1043 }
1044 ccomp date dt dtr dtd
1045
1046 dus() { # du, sorted, default arg of
1047 du -sh ${@:-*} | sort -h
1048 }
1049 ccomp du dus
1050
1051
1052 e() { printf "%s\n" "$*"; }
1053
1054 # echo args
1055 ea() {
1056 if (( ! $# )); then
1057 echo no args
1058 fi
1059 for arg; do
1060 printf "%qEOL\n" "${arg}"
1061 printf "%s" "${arg}" |& hexdump -C
1062 done
1063 }
1064
1065 # echo variables. print var including escapes, etc, like xxd for variable
1066 ev() {
1067 if (( ! $# )); then
1068 echo no args
1069 fi
1070 for arg; do
1071 if [[ -v $arg ]]; then
1072 printf "%qEOL\n" "${!arg}"
1073 printf "%s" "${!arg}" |& hexdump -C
1074 else
1075 echo arg $arg is unset
1076 fi
1077 done
1078 }
1079
1080 ediff() {
1081 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
1082 emacs --eval "(ediff-files \"$1\" \"$2\")"
1083 }
1084
1085 # mail related
1086 # shellcheck disable=SC2120 # we expect to pass arguments in use outside this file
1087 etail() {
1088 ngset
1089 tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
1090 ngreset
1091 }
1092 etailm() {
1093 tail -F /var/log/exim4/mainlog -n 200 "$@"
1094 }
1095 etail2() {
1096 tail -F /var/log/exim4/mymain -n 200 "$@"
1097 }
1098 ccomp tail etail etail2
1099
1100 # ran into this online, trying it out
1101 detach() {
1102 ( "$@" &>/dev/null & disown )
1103 }
1104
1105 showkeys() {
1106 ssh "$@" cat .ssh/authorized_keys{,2}
1107 }
1108
1109
1110 # print exim old pids
1111 eoldpids() {
1112 local configtime pid piduptime now daemonpid
1113 printf -v now '%(%s)T' -1
1114 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
1115 if [[ -s /run/exim4/exim.pid ]]; then
1116 daemonpid=$(cat /run/exim4/exim.pid)
1117 fi
1118 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
1119 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
1120 if [[ $pid == "$daemonpid" ]]; then
1121 continue
1122 fi
1123 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
1124 if (( configtime > now - piduptime )); then
1125 echo $pid
1126 fi
1127 done
1128 }
1129
1130 # exim tail but only watch lines from new pids
1131 etailnew() {
1132 local pid oldpids
1133 for pid in $(eoldpids); do
1134 oldpids+="$pid|"
1135 done
1136 if [[ $oldpids ]]; then
1137 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
1138 else
1139 etail
1140 fi
1141 }
1142 # exim watch as old pids go away
1143 ewatchold() {
1144 local configtime pid piduptime now tmpstr
1145 local -i count
1146 local -a oldpids
1147 count=0
1148 while true; do
1149 tmpstr=$(eoldpids)
1150 mapfile -t oldpids <<<"$tmpstr"
1151 if (( ! ${#oldpids[@]} )); then
1152 return
1153 fi
1154 # print the date every 20 iterations
1155 if (( ! count % 20 )); then
1156 date
1157 fi
1158 count+=1
1159 ps -f -p "${oldpids[*]}"
1160 sleep 1
1161 done
1162 }
1163
1164 eless() {
1165 less /var/log/exim4/mainlog
1166 }
1167 ccomp less eless
1168 eqcat() {
1169 exiqgrep -ir.\* -o 60 | while read -r i; do
1170 hlm exim -Mvc $i
1171 echo
1172 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
1173 done
1174 }
1175 eqrmf() {
1176 # other ways to get the list of message ids:
1177 # exim -bp | awk 'NF == 4 {print $3}'
1178 # # this is slower 160ms, vs 60.
1179 # exipick -i
1180 exiqgrep -ir.\* | xargs exim -Mrm
1181 }
1182
1183 econfdevnew() {
1184 rm -rf /tmp/edev
1185 mkdir -p /tmp/edev/etc
1186 cp -ra /etc/exim4 /tmp/edev/etc
1187 cp -ra /etc/alias* /tmp/edev/etc
1188 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
1189 econfdev
1190 }
1191 econfdev() {
1192 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
1193 }
1194
1195 # exim grep in
1196 # show important information about incoming mail in the exim log
1197 egrin() {
1198 sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p' <${1:-/var/log/exim4/mainlog}
1199 }
1200
1201 # 2nd line is message-id:
1202 egrinid() {
1203 sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).* id=([^ ]+) T="(.*)" from (<[^ ]+> .*$)/\1 \5\n \3\n \4/p' <${1:-/var/log/exim4/mainlog}
1204 }
1205 etailin() {
1206 tail -F /var/log/exim4/mainlog | sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p'
1207 }
1208
1209
1210
1211
1212 fa() {
1213 # find array. make an array of file names found by find into $x
1214 # argument: find arguments
1215 # return: find results in an array $x
1216 while read -rd ''; do
1217 x+=("$REPLY");
1218 done < <(find "$@" -print0);
1219 }
1220
1221 faf() { # find all files. use -L to follow symlinks
1222 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1223 -o -name .hg -prune -o -name .editor-backups -prune \
1224 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
1225 }
1226
1227 # usage ffconcat FILES_TO_CONCAT OUTPUT_FILE
1228 ffconcat() {
1229 local tmpf
1230 tmpf=$(mktemp)
1231 printf "file '%s'\n" "$1" >$tmpf
1232 while (( $# > 1 )); do
1233 shift
1234 printf "file '%s'\n" "$1" >>$tmpf
1235 done
1236 # https://trac.ffmpeg.org/wiki/Concatenate
1237 ffmpeg -f concat -safe 0 -i $tmpf -c copy "$1"
1238 rm $tmpf
1239 }
1240 ffremux() {
1241 local tmpf tmpd
1242 if (( $# == 0 )); then
1243 echo ffremux error expected args >&2
1244 return 1
1245 fi
1246 tmpd="$(mktemp -d)"
1247 for f; do
1248 tmpf=$tmpd/"${f##*/}"
1249 ffmpeg -i "$f" -c:v copy -c:a copy $tmpf
1250 cat $tmpf >"$f"
1251 done
1252 rm -r $tmpd
1253 }
1254
1255
1256
1257 # absolute path of file/dir without resolving symlinks.
1258 #
1259 # Most of the time, I want this where I would normally use readlink.
1260 # This is what realpath -s does in most cases, but sometimes it
1261 # actually resolves symlinks, at least when they are in /.
1262 #
1263 # Note, if run on a dir, if the final component is relative, it won't
1264 # resolve that. Use the below fpd for that.
1265 #
1266 # note: we could make a variation of this which
1267 # assigns to a variable name using eval, so that we don't have to do
1268 # x=$(fp somepath), which might save subshell overhead and look nice,
1269 # but I'm not going to bother.
1270 fp() {
1271 local initial_oldpwd initial_pwd dir base
1272 initial_oldpwd="$OLDPWD"
1273 initial_pwd="$PWD"
1274 if [[ $1 == */* ]]; then
1275 dir="${1%/*}"
1276 base="/${1##*/}"
1277 # CDPATH because having it set will cause cd to possibly print output
1278 CDPATH='' cd "$dir"
1279 printf "%s%s\n" "$PWD" "$base"
1280 CDPATH='' cd "$initial_pwd"
1281 OLDPWD="$initial_oldpwd"
1282 else
1283 printf "%s/%s\n" "$PWD" "$1"
1284 fi
1285 }
1286 # full path of directory without resolving symlinks
1287 fpd() {
1288 local initial_oldpwd initial_pwd dir
1289 initial_oldpwd="$OLDPWD"
1290 initial_pwd="$PWD"
1291 dir="$1"
1292 CDPATH='' cd "$dir"
1293 printf "%s%s\n" "$PWD" "$base"
1294 cd "$initial_pwd"
1295 OLDPWD="$initial_oldpwd"
1296 }
1297
1298
1299 # mail related
1300 frozen() {
1301 rm -rf /tmp/frozen
1302 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
1303 sudo exim -Mvl $id
1304 echo
1305 sudo exim -Mvh $id
1306 echo
1307 sudo exim -Mvb $id
1308 echo -e '\n\n##############################\n'
1309 done | tee -a /tmp/frozen
1310 }
1311 frozenrm() {
1312 local ids=()
1313 while read -r line; do
1314 printf '%s\n' "$line"
1315 ids+=("$(printf '%s\n' "$line" |gr frozen|awk '{print $3}')")
1316 done < <(s mailq)
1317 echo "sleeping for 2 in case you change your mind"
1318 sleep 2
1319 sudo exim -Mrm "${ids[@]}"
1320 }
1321
1322 funce() {
1323 # like -e for functions. returns on error.
1324 # at the end of the function, disable with:
1325 # trap ERR
1326 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1327 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1328 trap ERR
1329 return' ERR
1330 }
1331
1332 getdir () {
1333 local help="Usage: getdir [--help] PATH
1334 Output the directory of PATH, or just PATH if it is a directory."
1335 if [[ $1 == --help ]]; then
1336 echo "$help"
1337 return 0
1338 fi
1339 if [[ $# -ne 1 ]]; then
1340 echo "getdir error: expected 1 argument, got $#"
1341 return 1
1342 fi
1343 if [[ -d $1 ]]; then
1344 echo "$1"
1345 else
1346 local dir
1347 dir="$(dirname "$1")"
1348 if [[ -d $dir ]]; then
1349 echo "$dir"
1350 else
1351 echo "getdir error: directory does not exist"
1352 return 1
1353 fi
1354 fi
1355 }
1356
1357 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1358 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1359 local root
1360 root=$(gitroot) || return 1 # function to set gitroot
1361 builtin cd "$root"
1362 git symbolic-ref HEAD refs/heads/$1
1363 rm .git/index
1364 git clean -fdx
1365 }
1366
1367 # shellcheck disable=SC2120
1368 gitroot() {
1369 local help="Usage: gitroot [--help]
1370 Print the full path to the root of the current git repo
1371
1372 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1373 and works in older versions of git which did not have that."
1374 if [[ $1 == --help ]]; then
1375 echo "$help"
1376 return
1377 fi
1378 local p
1379 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1380 [[ $p != /* ]] && p=$PWD
1381 echo "${p%%/.git}"
1382 }
1383
1384 g() {
1385
1386 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1387 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1388
1389 local args gdb=false
1390
1391 if [[ $EMACSDIR ]]; then
1392 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1393 fi
1394
1395 if [[ $DISPLAY ]]; then
1396 args=-n
1397 fi
1398
1399 if (( $# == 0 )); then
1400 args+=" -c"
1401 fi
1402 # duplicate -c, but oh well
1403 if ! pgrep -u $EUID emacsclient; then
1404 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1405 gdb=true
1406 else
1407 args+=" -c"
1408 fi
1409 fi
1410 if [[ $EMACSDIR ]]; then
1411 # Alter the path here, otherwise the nfs mount gets triggered on the
1412 # first path lookup when emacs is not being used.
1413 # shellcheck disable=SC2098 disable=SC2097 # false positive
1414 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1415 else
1416 if $gdb; then
1417 # due to a bug, we cant debug from the start unless we get a new gdb
1418 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1419 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1420 m emacsclient -a "" $args "$@"
1421 sleep 1
1422 cd "/a/opt/emacs-$(distro-name)$(distro-num)"
1423 s gdb -p "$(pgrep -f 'emacs --daemon')" -ex c
1424 cd -
1425 else
1426 m emacsclient -a "" $args "$@"
1427 fi
1428 fi
1429 }
1430
1431 # force terminal version
1432 gn() {
1433 g -n "$@"
1434 }
1435
1436 gmacs() {
1437 # quit will prompt if the program crashes.
1438 gdb -ex=r -ex=quit --args emacs "$@"; r;
1439 }
1440
1441 gdkill() {
1442 # kill the emacs daemon
1443 pk1 emacs --daemon
1444 }
1445
1446 gr() {
1447 grep -iIP --color=auto "$@" || return $?
1448 }
1449 grr() { # grep recursive
1450 # Don't return 1 on nonmatch because this is meant to be
1451 # interactive, not in a conditional.
1452 if [[ ${#@} == 1 ]]; then
1453 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1454 else
1455 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1456 fi
1457 }
1458 ccomp grep gr grr
1459
1460 rg() { grr "$@"; }
1461 ccomp grep rg
1462
1463 # recursive everything. search for files/dirs and lines. rs = easy chars to press
1464 re() {
1465 local query
1466 query="$1"
1467 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1468 -o -name .hg -prune -o -name .editor-backups -prune \
1469 -o -name .undo-tree-history -prune \) 2>/dev/null | grep -iP --color=auto "$query"
1470 grr -m 5 "$@"
1471 }
1472
1473 # horizontal row. used to break up output
1474 hr() {
1475 local blocks
1476 # 180 is long enough.
1477 blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
1478 printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
1479 }
1480 # highlight
1481 hl() {
1482 local col input_len=0
1483 for arg; do
1484 input_len=$((input_len + 1 + ${#arg}))
1485 done
1486 col=$((60 - input_len))
1487 printf "\e[1;97;41m%s" "$*"
1488 if (( col > 0 )); then
1489 # shellcheck disable=SC2046 # needed to work as intended. a better way would be like hr above.
1490 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1491 fi
1492 echo
1493 }
1494 hlm() { hl "$*"; "$@"; }
1495
1496 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1497
1498
1499 # get latest hub and run it
1500 # main command to use:
1501 # hub pull-request --no-edit
1502 # --no-edit means to use the first commit\'s message as the pull request message.
1503 # If that fails, try doing
1504 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1505 # where branch is usually master. it does the pr against your current branch.
1506 #
1507 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1508 # it\'s at ~/.config/hub
1509 hub() {
1510 local up uptar updir p re
1511 # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
1512 up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
1513 re='[[:space:]]'
1514 if [[ ! $up || $up =~ $re ]]; then
1515 echo "failed to get good update url. got: $up"
1516 fi
1517 uptar=${up##*/}
1518 updir=${uptar%.tgz}
1519 if [[ ! -e /a/opt/$updir ]]; then
1520 rm -rf /a/opt/hub-linux-amd64*
1521 wget -P /a/opt $up
1522 tar -C /a/opt -zxf /a/opt/$uptar
1523 rm -f /a/opt/$uptar
1524 fi
1525 if ! which hub &>/dev/null; then
1526 sudo /a/opt/$updir/install
1527 fi
1528
1529 # save token across computers
1530 if [[ ! -L ~/.config/hub ]]; then
1531 if [[ -e ~/.config/hub ]]; then
1532 mv ~/.config/hub /p/c/subdir_files/.config/
1533 fi
1534 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1535 conflink
1536 fi
1537 fi
1538 command hub "$@"
1539 }
1540
1541 i() { git "$@"; }
1542 ccomp git i
1543
1544 # git status:
1545 # cvs -qn update
1546
1547 # git checkout FILE
1548 # cvs update -C FILE
1549
1550 # git pull
1551 # cvs up[date]
1552
1553 # potentially useful command translation
1554 # https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
1555
1556 # importing cvs repo into git using git-cvs package:
1557 # /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
1558
1559 ic() {
1560 # fast commit all
1561 git commit -am "$*"
1562 }
1563
1564 ipp() {
1565 git pull
1566 git push
1567 }
1568
1569 ifn() {
1570 local glob
1571 glob="$1"
1572 shift
1573 find -L "$@" -not \( -name .svn -prune -o -name .git -prune \
1574 -o -name .hg -prune -o -name .editor-backups -prune \
1575 -o -name .undo-tree-history -prune \) -iname "*$glob*" 2>/dev/null
1576 }
1577
1578 ifh() {
1579 # insensitive find here. args are combined into the search string.
1580 # -L = follow symlinks
1581 find -L . -not \( -name .svn -prune -o -name .git -prune \
1582 -o -name .hg -prune -o -name .editor-backups -prune \
1583 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1584 }
1585
1586 ifd() {
1587 # insensitive find directory
1588 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1589 -o -name .hg -prune -o -name .editor-backups -prune \
1590 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1591 }
1592
1593
1594 ipdrop() {
1595 sudo iptables -A INPUT -s $1 -j DROP
1596 }
1597
1598
1599 istext() {
1600 grep -Il "" "$@" &>/dev/null
1601 }
1602
1603 pst() {
1604 pstree -apnA
1605 }
1606
1607 # journalctl with times in the format the --since= and --until= options accept
1608 jrt() { journalctl -e -n100000 -o short-full "$@"; }
1609 jr() { journalctl -e -n100000 "$@" ; }
1610 jrf() { journalctl -n1000 -f "$@" ; }
1611 jru() {
1612 # the invocation id is "assigned each time the unit changes from an inactive
1613 # state into an activating or active state" man systemd.exec
1614 journalctl -e --no-tail -u exim4 _SYSTEMD_INVOCATION_ID="$(systemctl show -p InvocationID --value $1)"
1615 }
1616 ccomp journalctl jr jrf jru
1617
1618
1619
1620 l() {
1621 if [[ $PWD == /[iap] ]]; then
1622 command ls -A --color=auto -I lost+found "$@"
1623 else
1624 command ls -A --color=auto "$@"
1625 fi
1626 }
1627
1628 lcn() { locate -i "*$**"; }
1629
1630 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1631
1632 lt() { ll -tr "$@"; }
1633
1634 lld() { ll -d "$@"; }
1635
1636 ccomp ls l lg lt lld ll
1637
1638 # low recursively
1639 lowr() {
1640 local f dirs i a
1641 local -a all
1642 for dirs in false true; do
1643 for f; do
1644 if [[ -d $f ]]; then
1645 all=("$f"/**)
1646 # reverse the order to rename the nested dirs first.
1647 # note: 0 element is the dir itself
1648 for ((i=${#all[@]}-1; i>=1; i--)); do
1649 a="${all[i]}"
1650 if $dirs && [[ -d $a ]]; then
1651 # e dirs low "$a" # debug
1652 low "$a"
1653 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1654 # debug
1655 # e not dirs low "$a" # debug
1656 low "$a"
1657 fi
1658 done
1659 fi
1660 # just rename all the top level args on the second pass
1661 if $dirs; then
1662 # e final dirs low "$f" # debug
1663 low "$f"
1664 fi
1665 done
1666 done
1667 }
1668
1669 low() { # make filenames lowercase, remove bad chars
1670 local arg new dir f
1671 for arg; do
1672 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1673 dir="${arg%/*}"
1674 if (( ${#dir} == ${#arg} )); then
1675 dir=.
1676 fi
1677 f="${arg##*/}"
1678 new="${f,,}" # downcase
1679 # shellcheck disable=SC2031 # seems like a shellcheck bug
1680 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1681 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1682 new="${new%"${new##*[[:alnum:]]}"}"
1683 # remove bad underscores, like __ and _._
1684 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1685 safe_rename "$dir/$f" "$dir/$new" || return 1
1686 done
1687 return 0
1688 }
1689
1690 lower() { # make first letter of filenames lowercase.
1691 local x
1692 for x in "$@"; do
1693 if [[ ${x::1} == [A-Z] ]]; then
1694 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1695 safe_rename "$x" "$y" || return 1
1696 fi
1697 done
1698 }
1699
1700
1701 k() { # history search
1702 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1703 }
1704 ks() { # history search with context
1705 # args are an extended regex used by sed
1706 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1707 }
1708 ksu() { # history search unique
1709 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1710 }
1711
1712 # todo: id like to do maybe a daily or hourly cronjob to
1713 # check that my history file size is increasing. Ive had it
1714 # inexplicably truncated in the past.
1715 histrm() {
1716 history -n
1717 HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1718 read -r -p "press anything but contrl-c to delete"
1719 for entry in $(HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1720 history -d $entry
1721 done
1722 history -w
1723 }
1724
1725 # history without the date
1726 histplain() {
1727 history "$@" | cut -d' ' -f 7-
1728 }
1729
1730 ccomp grep k ks ksu histrm
1731
1732
1733 make-targets() {
1734 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1735 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1736 }
1737
1738 mkc() {
1739 mkdir "$1"
1740 c "$1"
1741 }
1742 ccomp mkdir mkc
1743
1744 mkct() {
1745 mkc "$(mktemp -d)"
1746 }
1747 # mkdir the last arg, cp the rest into it
1748 mkcp() {
1749 mkdir -p "${@: -1}"
1750 cp "${@:1:$#-1}" "${@: -1}"
1751 }
1752 mkmv() {
1753 mkdir -p "${@: -1}"
1754 mv "${@:1:$#-1}" "${@: -1}"
1755 }
1756
1757 mkt() { # mkdir and touch file
1758 local path="$1"
1759 mkdir -p "$(dirname "$path")"
1760 touch "$path"
1761 }
1762
1763 # shellcheck disable=SC2032
1764 mkdir() { command mkdir -p "$@"; }
1765
1766 nags() {
1767 # https://github.com/HenriWahl/Nagstamon/issues/357
1768 if ! pgrep -f /usr/bin/dunst >/dev/null; then
1769 /usr/bin/dunst &
1770 fi
1771 /usr/bin/nagstamon &
1772 }
1773
1774 # profanity screen
1775 profsrc() {
1776 screen -RD -S profanity
1777 }
1778
1779 # i dont want to wait for konsole to exit...
1780 prof() {
1781 command prof &>/dev/null &
1782 }
1783 # self chat
1784 sc() {
1785 while read -r l; do
1786 printf '\033[1A\033[K'; printf "%s\n" "$l"| ts "%F %T" | tee -a /p/self-chat.log
1787 done
1788 }
1789
1790 nmt() {
1791 # cant use s because sudo -i doesnt work for passwordless sudo command
1792 case $EUID in
1793 0)
1794 sudo nmtui-connect "$@"
1795 ;;
1796 *)
1797 nmtui-connect "$@"
1798 ;;
1799 esac
1800 }
1801
1802
1803 ngset() {
1804 if shopt nullglob >/dev/null; then
1805 ngreset=false
1806 else
1807 shopt -s nullglob
1808 ngreset=true
1809 fi
1810 }
1811 ngreset() {
1812 if $ngreset; then
1813 shopt -u nullglob
1814 fi
1815 }
1816
1817 nopanic() {
1818 # shellcheck disable=SC2024
1819 ngset
1820 for f in /var/log/exim4/paniclog /var/log/exim4/*panic; do
1821 base=${f##*/}
1822 if [[ -s $f ]]; then
1823 echo ================== $f =============
1824 s tee -a /var/log/exim4/$base-archive <$f
1825 s truncate -s0 $f
1826 fi
1827 done
1828 ngreset
1829 }
1830
1831
1832 ping() { command ping -O "$@"; }
1833 p8() { ping "$@" 8.8.8.8; }
1834 p6() { ping6 "$@" 2001:4860:4860::8888; }
1835
1836 pkx() { # package extract
1837 local pkg cached tmp f
1838 c "$(mktemp -d)"
1839 pkg=$1
1840 # shellcheck disable=SC2012
1841 cached=$(ls -t /var/cache/apt/archives/${pkg}_* | tail -n1 2>/dev/null) ||:
1842 if [[ $cached ]]; then
1843 m cp $cached .
1844 else
1845 m aptitude download $pkg || return 1
1846 fi
1847 tmp=(*); f=${tmp[0]} # only 1 expected
1848 m ex $f
1849 m rm -f $f
1850 }
1851
1852 # pgrep and kill
1853 pk1() {
1854 local tmpf
1855 local -a pids
1856 tmpf=$(pgrep -f "$*")
1857 mapfile -t pids <<<"$tmpf"
1858 case ${#pids[@]} in
1859 1)
1860 # shellcheck disable=SC2128
1861 {
1862 ps -F ${pids[0]}
1863 m kill ${pids[0]}
1864 }
1865 ;;
1866 0) echo "no pid found" ;;
1867 *)
1868 ps -F ${pids[@]}
1869 ;;
1870 esac
1871 }
1872
1873 psg () {
1874 local x y help
1875 help="Usage: psg [--help] GREP_ARGS
1876 grep ps and output in a nice format"
1877 if [[ $1 == --help ]]; then
1878 echo "$help"
1879 return
1880 fi
1881 x=$(ps -eF)
1882 # final grep is because some commands tend to have a lot of trailing spaces
1883 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1884 if [[ $y ]]; then
1885 echo "$x" | head -n 1 || [[ $? == 141 ]]
1886 echo "$y"
1887 fi
1888 }
1889
1890 pubip() { curl -4s https://icanhazip.com; }
1891 pubip6() { curl -6s https://icanhazip.com; }
1892 whatismyip() { pubip; }
1893
1894
1895 q() { # start / launch a program in the backround and redir output to null
1896 "$@" &> /dev/null &
1897 }
1898
1899 # shellcheck disable=SC2120
1900 r() {
1901 if [[ $HISTFILE ]]; then
1902 history -a # save history
1903 fi
1904 trap ERR # this avoids a segfault
1905 exit ${1:0}
1906 # i had this redir, not sure why
1907 # exit "$@" 2>/dev/null
1908 }
1909
1910 # scp is insecure and deprecated.
1911 scp() {
1912 rsync -Pt --inplace "$@"
1913 }
1914 ccomp rsync scp
1915
1916 randport() {
1917 # available high ports are 1024-65535,
1918 # but lets skip things that are more likely to be in use
1919 python3 <<'EOF'
1920 import secrets
1921 print(secrets.SystemRandom().randrange(10002,65500))
1922 EOF
1923 }
1924
1925 # reapply bashrc
1926 reb() {
1927 # shellcheck disable=SC1090 # expected to not follow
1928 source ~/.bashrc
1929 }
1930
1931 rl() {
1932 readlink -f "$@"
1933 }
1934 ccomp readlink rl
1935
1936 rsd() {
1937 # rsync, root is required to keep permissions right.
1938 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1939 # --no-times --delete
1940 # basically, make an exact copy, use checksums instead of file times to be more accurate
1941 rsync -ahvic --delete "$@"
1942 }
1943 rsa() {
1944 # like rlu, but dont delete files on the target end which
1945 # do not exist on the original end.
1946 rsync -ahvic "$@"
1947 }
1948 rst() {
1949 # rl without preserving modification time.
1950 rsync -ahvic --delete --no-t "$@"
1951 }
1952 # [RSYNC_OPTS] HOST PATH
1953 rsu() {
1954 # eg. rsu -opts frodo /testpath
1955 # relative paths will expanded with readlink -f.
1956 opts=("${@:1:$#-2}") # 1 to last -2
1957 path="${*:$#}" # last
1958 host="${*:$#-1:1}" # last -1
1959 if [[ $path == .* ]]; then
1960 path=$(readlink -f $path)
1961 fi
1962 m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
1963 }
1964 ccomp rsync rsd rsa rst rsu
1965
1966 # find programs listening on a port
1967 ssp() {
1968 local port=$1
1969 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1970 s ss -lpn state listening sport = $port
1971 }
1972
1973 resolvcat() {
1974 local f
1975 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1976 m s nscd -i hosts
1977 fi
1978 f=/etc/resolv.conf
1979 echo $f:; ccat $f
1980 hr; s ss -lpn sport = 53
1981 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1982 # this will fail is dnsmasq is failed
1983 hr; m ser status dnsmasq | cat || :
1984 f=/etc/dnsmasq.conf
1985 hr; echo $f:; ccat $f
1986 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1987 f=/etc/dnsmasq-servers.conf
1988 hr; echo $f:; ccat $f
1989 fi
1990 hr
1991 echo /etc/nsswitch.conf:
1992 grep '^ *hosts:' /etc/nsswitch.conf
1993 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1994 hr; m ser status systemd-resolved | cat || :
1995 hr; m resolvectl status | cat
1996 fi
1997
1998 }
1999 rcat() {
2000 resolvcat | less
2001 }
2002 reresolv() {
2003 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
2004 m ser stop nscd
2005 sleep .5
2006 m ser start nscd
2007 m sudo nscd -i hosts
2008 fi
2009 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
2010 m sudo systemctl restart dnsmasq
2011 fi
2012 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
2013 m sudo systemctl restart systemd-resolved
2014 fi
2015 if type -P resolvectl &>/dev/null; then
2016 resolvectl flush-caches
2017 fi
2018 }
2019
2020 # add annoyingly long argument which should be the default
2021 sedi() {
2022 sed -i --follow-symlinks "$@"
2023 }
2024
2025 rmstrips() {
2026 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
2027 }
2028
2029 urun () {
2030 umask $1
2031 shift
2032 "$@"
2033 }
2034 sudo () {
2035 command sudo "$@" || return $?
2036 DID_SUDO=true
2037 }
2038 s() {
2039 # background
2040 # I use a function because otherwise we cant use in a script,
2041 # cant assign to variable.
2042 #
2043 # note: gksudo is recommended for X apps because it does not set the
2044 # home directory to the same, and thus apps writing to ~ fuck things up
2045 # with root owned files.
2046 #
2047 if [[ $EUID != 0 || $1 == -* ]]; then
2048 # shellcheck disable=SC2034
2049 SUDOD="$PWD" command sudo -i "$@"
2050 DID_SUDO=true
2051 else
2052 "$@"
2053 fi
2054 }
2055 sb() { # sudo bash -c
2056 # use sb instead of s is for sudo redirections,
2057 # eg. sb 'echo "ok fine" > /etc/file'
2058 # shellcheck disable=SC2034
2059 local SUDOD="$PWD"
2060 sudo -i bash -c "$@"
2061 }
2062 # secret sudo
2063 se() { s urun 0077 "$@"; }
2064 ccomp sudo s sb se
2065
2066 safe_rename() { # warn and dont rename if file exists.
2067 # mv -n exists, but it\'s silent
2068 if [[ $# != 2 ]]; then
2069 echo safe_rename error: $# args, need 2 >&2
2070 return 1
2071 fi
2072 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
2073 if [[ -e $2 || -L $2 ]]; then
2074 echo "Cannot rename $1 to $2 as it already exists."
2075 else
2076 mv -vi "$1" "$2"
2077 fi
2078 fi
2079 }
2080
2081
2082 sd() {
2083 sudo dd status=none of="$1"
2084 }
2085
2086 ser() {
2087 if type -p systemctl &>/dev/null; then
2088 s systemctl "$@"
2089 else
2090 if (( $# >= 3 )); then
2091 echo iank: ser expected 2 or less arguments
2092 return 1
2093 fi
2094 s service $2 $1
2095 fi
2096 }
2097 serstat() {
2098 systemctl -n 40 status "$@"
2099 }
2100
2101 seru() { systemctl --user "$@"; }
2102 # like restart, but do nothing if its not already started
2103 srestart() {
2104 local service=$1
2105 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
2106 systemctl restart $service
2107 fi
2108 }
2109
2110 setini() { # set a value in a .ini style file
2111 key="$1" value="$2" section="$3" file="$4"
2112 if [[ -s $file ]]; then
2113 sed -ri -f - "$file" <<EOF
2114 # remove existing keys
2115 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*${key}[[:space:]=]/d}
2116 # add key
2117 /^\s*\[$section\]/a $key=$value
2118 # from section to eof, do nothing
2119 /^\s*\[$section\]/,\$b
2120 # on the last line, if we haven't found section yet, add section and key
2121 \$a [$section]\\
2122 $key=$value
2123 EOF
2124 else
2125 cat >"$file" <<EOF
2126 [$section]
2127 $key=$value
2128 EOF
2129 fi
2130 }
2131
2132 sgo() { # service go
2133 service=$1
2134 ser restart $service || return 1
2135 if type -p systemctl &>/dev/null; then
2136 ser enable $service
2137 fi
2138 }
2139 soff () {
2140 for service; do
2141 # ignore services that dont exist
2142 if systemctl cat $service &>/dev/null; then
2143 ser stop $service;
2144 ser disable $service
2145 fi
2146 done
2147 }
2148
2149 sgu() {
2150 systemctl list-unit-files | rg "$@"
2151 }
2152
2153
2154 sk() {
2155 # disable a warning with:
2156 # shellcheck disable=SC2206 # reasoning
2157
2158 # see bash-template/style-guide.md for justifications
2159
2160 local quotes others
2161 quotes=2048,2068,2086,2206,2254
2162 others=2029,2032,2033,2054,2164,
2163 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
2164 }
2165 # sk with quotes. For checking scripts that we expect to take untrusted
2166 # input in order to verify we quoted vars.
2167 skq() {
2168 local others
2169 others=2029,2033,2054,2164
2170 shellcheck -W 999 -x -e $others "$@" || return $?
2171 }
2172
2173 skgit() {
2174 local f
2175 for f in $(i s | awk '$1 == "modified:" {print $2}'); do
2176 if [[ $(head -n1 "$f") == '#!/bin/bash'* ]]; then
2177 sk $f ||:
2178 fi
2179 done
2180 }
2181
2182 # sl: ssh, but firsh rsync our bashrc and related files to a special
2183 # directory on the remote host if needed.
2184
2185 # Some environment variables and files need to be setup for this to work
2186 # (mine are set at the beginning of this file)
2187
2188 # SL_FILES_DIR: Environment variable. Path to folder which should at
2189 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
2190 # remote hosts (top level symlinks are resolved) unless the host already
2191 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
2192 # control and sync files to separately and already has the ~/.bashrc you
2193 # want. The remote bash will also take its .inputrc config from this
2194 # folder (default of not existing is fine). Mine looks like this:
2195 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
2196
2197 # SL_INFO_DIR: Environment variable. This folder stores info about what
2198 # we detected on the remote system and when we last synced. It will be created
2199 # if it does not exist. Sometimes you may want to forget about a
2200 # remote system, you can use sl --rsync, or the function for that slr
2201 # below.
2202
2203 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
2204 # depending on the remote host. Run this string on the remote host the
2205 # first time sl is run (or if we run slr). The result is passed to
2206 # SL_TEST_HOOK. For example,
2207 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
2208
2209 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
2210 # $SL_FILES_DIR to vary the files synced.
2211
2212 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
2213 # example to exclude files within a directory. Note, excluded
2214 # files wont be deleted on rsync, you can add --delete-excluded
2215 # to the rsync command if that is desired.
2216
2217 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
2218
2219 # For when ~/.bashrc is already customized on the remote server, you
2220 # might find it problematic that ~/.bashrc is sourced for ALL ssh
2221 # commands, even in scripts. This paragraph is all about that. bash
2222 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
2223 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
2224 # and if you customize it, probably has bugs from time to time. This is
2225 # bad. Here's how I fix it. I have a special condition to "return" in my
2226 # .bashrc for noninteractive ssh shells (copy that code). Then use this
2227 # function or similar that passes LC_USEBASHRC=t when sshing and I want
2228 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
2229 # separate file because even if I return early on, the whole file gets
2230 # parsed which can fail if there is a syntax error.
2231 sl() {
2232 # Background on LC_USEBASHRC var (no need to read if you just want to
2233 # use this function): env variables sent across ssh are strictly
2234 # limited, but we get LC_* at least in debian based machines, so we
2235 # just make that * be something no normal program would use. Note, on
2236 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
2237 # set, and the inner shell also allows running a nondefault
2238 # .bashrc. This means the outer shell still ran the default .bashrc,
2239 # but that is the best we can do.
2240
2241 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
2242 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
2243 declare -a args tmpa
2244
2245 args=($SL_SSH_ARGS)
2246
2247 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
2248 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
2249 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
2250 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
2251 # [command]
2252
2253 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
2254 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
2255 # [-F configfile] [-I pkcs11] [-i identity_file]
2256 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
2257 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
2258 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
2259
2260 force_rsync=false
2261 if [[ $1 == --rsync ]]; then
2262 force_rsync=true
2263 shift
2264 fi
2265 # shellcheck disable=SC2153 # intentional
2266 sl_test_cmd=$SL_TEST_CMD
2267 # shellcheck disable=SC2153 # intentional
2268 sl_test_hook=$SL_TEST_HOOK
2269 # shellcheck disable=SC2153 # intentional
2270 sl_rsync_args=$SL_RSYNC_ARGS
2271 while [[ $1 ]]; do
2272 case "$1" in
2273 --rsync)
2274 force_rsync=true
2275 ;;
2276 --sl-test-cmd)
2277 sl_test_cmd="$2"
2278 shift
2279 ;;
2280 --sl-test-hook)
2281 sl_test_hook="$2"
2282 shift
2283 ;;
2284 --sl-rsync-args)
2285 sl_rsync_args="$2"
2286 shift
2287 ;;
2288 *)
2289 break
2290 ;;
2291 esac
2292 shift
2293 done
2294
2295 while [[ $1 ]]; do
2296 case "$1" in
2297 # note we dont support things like -4oOption
2298 -[46AaCfGgKkMNnqsTtVvXxYy]*)
2299 args+=("$1"); shift
2300 ;;
2301 -[bcDEeFIiJLlmOopQRSWw]*)
2302 # -oOption etc is valid
2303 if (( ${#1} >= 3 )); then
2304 args+=("$1"); shift
2305 else
2306 args+=("$1" "$2"); shift 2
2307 fi
2308 ;;
2309 *)
2310 break
2311 ;;
2312 esac
2313 done
2314 remote="$1"
2315 if [[ ! $remote ]]; then
2316 echo $0: error hostname required >&2
2317 return 1
2318 fi
2319 shift
2320
2321 if [[ ! $SL_INFO_DIR ]]; then
2322 echo 'error: missing SL_INFO_DIR env var' >&2
2323 return 1
2324 fi
2325
2326 dorsync=false
2327 haveinfo=false
2328 tmpa=($SL_INFO_DIR/???????????"$remote")
2329 sshinfo=${tmpa[0]}
2330 if [[ -e $sshinfo ]]; then
2331 if $force_rsync; then
2332 rm -f $sshinfo
2333 else
2334 haveinfo=true
2335 fi
2336 fi
2337 if $haveinfo; then
2338 tmp=${sshinfo[0]##*/}
2339 tmp2=${tmp::11}
2340 type=${tmp2: -1}
2341 extra_info=$(cat $sshinfo)
2342 else
2343 # we test for string to know ssh succeeded
2344 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
2345 testcmd="if $testbool; then printf y; else printf n; fi"
2346 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
2347 echo failed sl test. doing plain ssh -v
2348 command ssh -v "${args[@]}" "$remote"
2349 fi
2350 if [[ $tmp == y* ]]; then
2351 type=a
2352 else
2353 dorsync=true
2354 type=b
2355 fi
2356 extra_info="${tmp:1}"
2357 fi
2358 if [[ $sl_test_hook ]]; then
2359 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
2360 fi
2361
2362 if $haveinfo && [[ $type == b ]]; then
2363 info_sec=${tmp::10}
2364 read -r files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
2365 files_sec=${files_sec%%.*}
2366 if (( files_sec > info_sec )); then
2367 dorsync=true
2368 rm -f $sshinfo
2369 fi
2370 fi
2371
2372 sync_dirname=${SL_FILES_DIR##*/}
2373
2374 if [[ ! $SL_FILES_DIR ]]; then
2375 echo 'error: missing SL_FILES_DIR env var' >&2
2376 return 1
2377 fi
2378
2379 if $dorsync; then
2380 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
2381 fi
2382 if $dorsync || ! $haveinfo; then
2383 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
2384 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
2385 printf "%s\n" "$extra_info" >$sshinfo
2386 chmod 666 $sshinfo
2387 fi
2388 if [[ $type == b ]]; then
2389 if (( ${#@} )); then
2390 # Theres a couple ways to pass arguments, im not sure whats best,
2391 # but relying on bash 4.4+ escape quoting seems most reliable.
2392 command ssh "${args[@]}" "$remote" \
2393 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
2394 elif [[ ! -t 0 ]]; then
2395 # This case is when commands are being piped to ssh.
2396 # Normally, no bashrc gets sourced.
2397 # But, since we are doing all this, lets source it because we can.
2398 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2399 else
2400 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
2401 fi
2402 else
2403 if [[ -t 0 ]]; then
2404 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
2405 else
2406 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2407 fi
2408 fi
2409 # this function inspired from https://github.com/Russell91/sshrc
2410 }
2411
2412 slr() {
2413 sl --rsync "$@"
2414 }
2415 sss() { # ssh solo
2416 sl -oControlMaster=no -oControlPath=/ "$@"
2417 }
2418 # kill off old shared socket then ssh
2419 ssk() {
2420 m ssh -O exit "$@" || [[ $? == 255 ]]
2421 m sl "$@"
2422 }
2423 ccomp ssh sl slr sss ssk
2424 # plain ssh
2425 ssh() {
2426 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
2427 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
2428 else
2429 LC_USEBASHRC=t command ssh "$@"
2430 fi
2431 }
2432
2433
2434 slog() {
2435 # log with script. timing is $1.t and script is $1.s
2436 # -l to save to ~/typescripts/
2437 # -t to add a timestamp to the filenames
2438 local logdir do_stamp arg_base
2439 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
2440 logdir="/a/dt/"
2441 do_stamp=false
2442 while getopts "lt" option
2443 do
2444 case $option in
2445 l) arg_base=$logdir ;;
2446 t) do_stamp=true ;;
2447 *)
2448 echo error: bad option
2449 return 1
2450 ;;
2451 esac
2452 done
2453 shift $((OPTIND - 1))
2454 arg_base+=$1
2455 [[ -e $logdir ]] || mkdir -p $logdir
2456 $do_stamp && arg_base+=$(date +%F.%T%z)
2457 script -t $arg_base.s 2> $arg_base.t
2458 }
2459 splay() { # script replay
2460 #logRoot="$HOME/typescripts/"
2461 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2462 scriptreplay "$1.t" "$1.s"
2463 }
2464
2465 sr() {
2466 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2467 if [[ $# == 0 ]]; then
2468 sudo -E bash -c -l "$(history -p '!!')"
2469 else
2470 echo this command redos last history item. no argument is accepted
2471 fi
2472 }
2473
2474 srm () {
2475 # with -ll, less secure but faster.
2476 command srm -ll "$@"
2477 }
2478
2479 srun() {
2480 scp $2 $1:/tmp
2481 ssh $1 "/tmp/${2##*/}" "$(printf "%q\n" "${@:2}")"
2482 }
2483
2484
2485 swap() {
2486 local tmp
2487 tmp=$(mktemp)
2488 mv $1 $tmp
2489 mv $2 $1
2490 mv $tmp $2
2491 }
2492
2493 tclock() { # terminal clock
2494 local x
2495 clear
2496 date +%l:%_M
2497 len=60
2498 # this goes to full width
2499 #len=${1:-$((COLUMNS -7))}
2500 x=1
2501 while true; do
2502 if (( x == len )); then
2503 end=true
2504 d="$(date +%l:%_M) "
2505 else
2506 end=false
2507 d=$(date +%l:%M:%_S)
2508 fi
2509 echo -en "\r"
2510 echo -n "$d"
2511 for ((i=0; i<x; i++)); do
2512 if (( i % 6 )); then
2513 echo -n _
2514 else
2515 echo -n .
2516 fi
2517 done
2518 if $end; then
2519 echo
2520 x=1
2521 else
2522 x=$((x+1))
2523 fi
2524 sleep 5
2525 done
2526 }
2527
2528
2529 te() {
2530 # test existence / exists
2531 local ret=0
2532 for x in "$@"; do
2533 [[ -e "$x" || -L "$x" ]] || ret=1
2534 done
2535 return $ret
2536 }
2537
2538 psoff() {
2539 # normally, i would just execute these commands in the function.
2540 # however, DEBUG is not inherited, so we need to run it outside a function.
2541 # And we want to run set -x afterwards to avoid spam, so we cram everything
2542 # in here, and then it will run after this function is done.
2543 # # set as array to satisfy shellcheck, but it is equivalent to setting it as non-array
2544 PROMPT_COMMAND=('trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "')
2545 }
2546 pson() {
2547 PROMPT_COMMAND=(prompt-command)
2548 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2549 trap 'settitle "$BASH_COMMAND"' DEBUG
2550 fi
2551 }
2552
2553 # prometheus node curl
2554 pnodecurl() {
2555 local host
2556 host=${1:-127.0.0.1}
2557 s curl --cert-type PEM --cert /etc/prometheus/ssl/prometheus_cert.pem --key /etc/prometheus/ssl/prometheus_key.pem --cacert /etc/prometheus/ssl/prom_node_cert.pem --resolve prom_node:9100:$host -v https://prom_node:9100/metrics
2558 }
2559
2560 tx() { # toggle set -x, and the prompt so it doesnt spam
2561 if [[ $- == *x* ]]; then
2562 set +x
2563 pson
2564 else
2565 psoff
2566 fi
2567 }
2568
2569 psnetns() {
2570 # show all processes in the network namespace $1.
2571 # blank entries appear to be subprocesses/threads
2572 local x netns
2573 netns=$1
2574 ps -w | head -n 1
2575 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2576 while read -r l; do
2577 x=$(ps -w --no-headers -p $l);
2578 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2579 done
2580 }
2581 nonet() {
2582 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2583 s ip netns add nonet
2584 fi
2585 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2586 }
2587
2588 m() { printf "%s\n" "$*"; "$@"; }
2589
2590 # update file. note: duplicated in mail-setup.
2591 # updates $ur u result to true or false
2592 # updates $reload to true if file updated is in /etc/systemd/system
2593 u() {
2594 local tmp tmpdir dest="$1"
2595 local base="${dest##*/}"
2596 local dir="${dest%/*}"
2597 if [[ $dir != "$base" ]]; then
2598 # dest has a directory component
2599 mkdir -p "$dir"
2600 fi
2601 # shellcheck disable=SC2034 # see comment at top of function
2602 ur=false # u result
2603 tmpdir="$(mktemp -d)"
2604 cat >$tmpdir/"$base"
2605 tmp=$(rsync -ic $tmpdir/"$base" "$dest")
2606 if [[ $tmp ]]; then
2607 printf "%s\n" "$tmp"
2608 # shellcheck disable=SC2034 # see comment at top of function
2609 ur=true
2610 if [[ $dest == /etc/systemd/system/* ]]; then
2611 # shellcheck disable=SC2034 # see comment at top of function
2612 reload=true
2613 fi
2614 fi
2615 rm -rf $tmpdir
2616 }
2617
2618
2619 uptime() {
2620 if type -p uprecords &>/dev/null; then
2621 uprecords -B
2622 else
2623 command uptime
2624 fi
2625 }
2626
2627 virshrm() {
2628 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2629 }
2630
2631 vm-set-listen(){
2632 local t
2633 t=$(mktemp)
2634 local vm=$1
2635 local ip=$2
2636 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2637 sed -r "s/listen='[^']+/listen='$ip/"> $t
2638 sudo virsh undefine $vm
2639 sudo virsh define $t
2640 }
2641
2642
2643 vmshare() {
2644 vm-set-listen $1 0.0.0.0
2645 }
2646
2647
2648 vmunshare() {
2649 vm-set-listen $1 127.0.0.1
2650 }
2651
2652 myiwscan() {
2653 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2654 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2655 sudo iw dev wls1 scan | sed -rn "
2656 s/^\Wcapability: (.*)/\1/;Ta;h;b
2657 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2658 # padded to min width of 20
2659 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2660 "|sort -r
2661 }
2662
2663 # Run script by copying it to a temporary location first,
2664 # and changing directory, so we don't have any open
2665 # directories or files that could cause problems when
2666 # remounting.
2667 zr() {
2668 local tmp
2669 tmp=$(type -p "$1")
2670 if [[ $tmp ]]; then
2671 cd "$(mktemp -d)"
2672 cp -a "$tmp" .
2673 shift
2674 ./"${tmp##*/}" "$@"
2675 else
2676 "$@"
2677 fi
2678 }
2679
2680
2681 # * spark
2682 # spark 1 5 22 13 53
2683 # # => ▁▁▃▂▇
2684
2685 # The MIT License
2686 # Copyright (c) Zach Holman, https://zachholman.com
2687 # https://github.com/holman/spark
2688
2689 # As of 2022-10-28, I reviewed github forks that had several newer
2690 # commits, none had anything interesting. I did a little refactoring
2691 # mostly to fix emacs indent bug.
2692
2693 # Generates sparklines.
2694 _spark_echo()
2695 {
2696 if [ "X$1" = "X-n" ]; then
2697 shift
2698 printf "%s" "$*"
2699 else
2700 printf "%s\n" "$*"
2701 fi
2702 }
2703
2704
2705 spark()
2706 {
2707 local f tc
2708 local n numbers=
2709
2710 # find min/max values
2711 local min=0xffffffff max=0
2712
2713 for n in ${@//,/ }
2714 do
2715 # on Linux (or with bash4) we could use `printf %.0f $n` here to
2716 # round the number but that doesn't work on OS X (bash3) nor does
2717 # `awk '{printf "%.0f",$1}' <<< $n` work, so just cut it off
2718 n=${n%.*}
2719 (( n < min )) && min=$n
2720 (( n > max )) && max=$n
2721 numbers=$numbers${numbers:+ }$n
2722 done
2723
2724 # print ticks
2725 local ticks=(▁ ▂ ▃ ▄ ▅ ▆ ▇ █)
2726
2727 # use a high tick if data is constant
2728 (( min == max )) && ticks=(▅ ▆)
2729
2730 tc=${#ticks[@]}
2731 f=$(( ( (max-min) <<8)/( tc - 1) ))
2732 (( f < 1 )) && f=1
2733
2734 for n in $numbers
2735 do
2736 _spark_echo -n ${ticks[$(( (((n-min)<<8)/f) ))]}
2737 done
2738 _spark_echo
2739 }
2740
2741 pdfwc() { local f; for f; do echo "$f" "$(pdfinfo "$f" | awk '/^Pages:/ {print $2}')"; done }
2742
2743
2744 # nvm install script appended this to my .bashrc. I dont want to run it all the time,
2745 # so put it in a function.
2746 nvm-init() {
2747 export NVM_DIR="$HOME/.nvm"
2748 # shellcheck disable=SC1091 # may not exist, & third party
2749 [ -s "$NVM_DIR/nvm.sh" ] && source "$NVM_DIR/nvm.sh" # This loads nvm
2750 # shellcheck disable=SC1091 # may not exist, & third party
2751 [ -s "$NVM_DIR/bash_completion" ] && source "$NVM_DIR/bash_completion" # This loads nvm bash_completion
2752 }
2753
2754
2755 leap-year() {
2756 if date -d 'february 29' &>/dev/null; then
2757 year_days=366
2758 else
2759 year_days=365
2760 fi
2761 echo $year_days
2762 }
2763
2764 # on-battery
2765 on-bat() {
2766 if [[ -e /sys/class/power_supply/AC/online && $(</sys/class/power_supply/AC/online) == 0 ]]; then
2767 return 1
2768 fi
2769 }
2770
2771 # make vim work with my light colortheme terminal.
2772 vim() {
2773 if [[ -e ~/.vimrc ]]; then
2774 command vim "$@"
2775 else
2776 command vim -c ':colorscheme peachpuff' "$@"
2777 fi
2778 }
2779
2780 # ls count. usage: pass a directory, get the number of files.
2781 # https://unix.stackexchange.com/questions/90106/whats-the-most-resource-efficient-way-to-count-how-many-files-are-in-a-director
2782 lsc() {
2783 ls -Uq "$@"|wc -l
2784 }
2785
2786 # run then notify. close notification after the next prompt.
2787 rn() {
2788 "$@"
2789 dunstify -u critical "$*"
2790 _psrun=(dunstctl close-all)
2791 }
2792 n() {
2793 dunstify -u critical n
2794 _psrun=(dunstctl close-all)
2795 }
2796
2797 catnew() {
2798 local dir file
2799 dir="$1"
2800 inotifywait -m "$dir" -e create -e moved_to | while read -r _ _ file; do
2801 hr
2802 cat "$dir/$file"
2803 done
2804 }
2805 # cat mail
2806 cm() {
2807 catnew /m/md/$1/new
2808 }
2809
2810
2811 # * misc stuff
2812
2813
2814 if $use_color && type -p tput &>/dev/null; then
2815 term_bold="$(tput bold)"
2816 term_red="$(tput setaf 1)"
2817 term_green="$(tput setaf 2)"
2818 # shellcheck disable=SC2034 # expected
2819 term_yellow="$(tput setaf 3)"
2820 term_purple="$(tput setaf 5)"
2821 term_nocolor="$(tput sgr0)" # no font attributes
2822
2823 # unused so far. commented for shellcheck
2824 # term_underl="$(tput smul)"
2825 # term_blue="$(tput setaf 4)"
2826 # term_cyan="$(tput setaf 6)"
2827 fi
2828 # Try to keep environment pollution down, EPA loves us.
2829 unset safe_term match_lhs use_color
2830
2831 # * prompt
2832
2833
2834 if [[ $- == *i* ]]; then
2835
2836
2837 case $HOSTNAME in
2838 bk|je|li)
2839 if [[ $EUID == 1000 ]]; then
2840 system-status _ ||:
2841 fi
2842 ;;
2843 esac
2844
2845
2846 # this needs to come before next ps1 stuff
2847 # this stuff needs bash 4, feb 2009,
2848 # old enough to no longer condition on $BASH_VERSION anymore
2849 shopt -s autocd
2850 shopt -s dirspell
2851 PS1='\w'
2852 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2853 PROMPT_DIRTRIM=2
2854 bind -m vi-command B:shell-backward-word
2855 bind -m vi-command W:shell-forward-word
2856 fi
2857
2858 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2859 unset PROMPT_DIRTRIM
2860 PS1="\h:$PS1"
2861 fi
2862
2863 # emacs terminal has problems if this runs slowly,
2864 # so I've thrown a bunch of things at the wall to speed it up.
2865 prompt-command() {
2866 local return=$? # this MUST COME FIRST
2867 local ps_char ps_color
2868 unset IFS
2869
2870 if [[ $HISTFILE ]]; then
2871 history -a # save history
2872 fi
2873
2874 case $return in
2875 0) ps_color="$term_purple"
2876 ps_char='\$'
2877 ;;
2878 *) ps_color="$term_green"
2879 ps_char="$return \\$"
2880 ;;
2881 esac
2882 if [[ ! -O . ]]; then # not owner
2883 if [[ -w . ]]; then # writable
2884 ps_color="$term_bold$term_red"
2885 else
2886 ps_color="$term_bold$term_green"
2887 fi
2888 fi
2889
2890 # faster than sourceing the file im guessing
2891 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2892 eval "$(< /dev/shm/iank-status)"
2893 fi
2894 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2895 ps_char="@ $ps_char"
2896 fi
2897 jobs_char=
2898 if [[ $(jobs -p) ]]; then
2899 jobs_char='j\j '
2900 fi
2901
2902
2903 # allow a function to specify a command to run after we run the next
2904 # command. Use case: a function makes a persistent notification. If
2905 # we happen to be using that terminal, we can just keep working by
2906 # entering our next command, even a noop in order to dismiss the
2907 # notification, instead of having to explicitly dismiss it.
2908 if [[ ${_psrun[@]} ]]; then
2909 if (( _psrun_count >= 1 )); then
2910
2911 "${_psrun[@]}" ||:
2912 _psrun_count=0
2913 unset _psrun
2914 else
2915 _psrun_count=$(( _psrun_count + 1 ))
2916 fi
2917 else
2918 _psrun_count=0
2919 fi
2920
2921 # We could test if sudo is active with sudo -nv
2922 # but then we get an email and log of lots of failed sudo commands.
2923 # We could turn those off, but seems better not to.
2924 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2925 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2926 fi
2927 if [[ ! $HISTFILE ]]; then
2928 ps_char="NOHIST $ps_char"
2929 fi
2930 PS1="${PS1%"${PS1#*[wW]}"} $jobs_char$psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2931
2932 # copy of what is automatically added by guix.
2933 # adds [env] to PS1 if GUIX_ENVIRONMENT is set and PS1 contains '$';
2934 if [ -n "$GUIX_ENVIRONMENT" ]; then
2935 if [[ $PS1 =~ (.*)"\\$" ]]; then
2936 PS1="${BASH_REMATCH[1]} [env]\\\$ "
2937 fi
2938 fi
2939
2940
2941 # set titlebar. instead, using more advanced
2942 # titelbar below
2943 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2944 }
2945 PROMPT_COMMAND=(prompt-command)
2946
2947 if [[ $TERM == screen* ]]; then
2948 _title_escape="\033]..2;"
2949 else
2950 # somme sites recommend this, i dunno what the diff is.
2951 #_title_escape="\033]30;"
2952 _title_escape="\033]0;"
2953 fi
2954
2955 # make the titlebar be the last command and the current directory.
2956 settitle () {
2957
2958
2959 # These are some checks to help ensure we dont set the title at
2960 # times that the debug trap is running other than the case we
2961 # want. Some of them might not be needed.
2962 if (( ${#FUNCNAME[@]} != 1 || ${#BASH_ARGC[@]} != 2 || BASH_SUBSHELL != 0 )); then
2963 return 0
2964 fi
2965 if [[ $1 == prompt-command ]]; then
2966 return 0
2967 fi
2968 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2969 printf "%s" "$*"
2970 echo -ne "\007"
2971 }
2972
2973 # note, this wont work:
2974 # x=$(mktemp); cp a $x
2975 # I havnt figured out why, bigger fish to fry.
2976 #
2977 # for titlebar.
2978 # condition from the screen man page i think.
2979 # note: duplicated in tx()
2980 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2981 trap 'settitle "$BASH_COMMAND"' DEBUG
2982 else
2983 trap DEBUG
2984 fi
2985
2986 fi
2987
2988 # * stuff that makes sense to be at the end
2989
2990
2991 # best practice
2992 unset IFS
2993
2994 if [[ -s "$HOME/.rvm/scripts/rvm" ]]; then
2995 # shellcheck disable=SC1091
2996 source "$HOME/.rvm/scripts/rvm"
2997 fi
2998
2999 # I had this idea to start a bash shell which would run an initial
3000 # command passed through this env variable, then continue on
3001 # interactively. But the use case I had in mind went away.
3002 #
3003 # if [[ $MY_INIT_CMD ]]; then
3004 # "${MY_INIT_CMD[@]}"
3005 # unset MY_INIT_CMD
3006 # fi
3007
3008 # ensure no bad programs appending to this file will have an affect
3009 return 0